GNUNET-SEARCH(1)

NAME
gnunet-search - a command line interface to search for content on GNUnet

SYNOPSIS
gnunet-search [-a LEVEL | --anonymity=LEVEL] [-c FILENAME | --config=FILENAME] [-h | --help] [-L LOGLEVEL | --loglevel=LOGLEVEL] [-l FILENAME | --logfile=FILENAME] [-o FILENAME | --output=FILENAME] [-n | --no-network] [-N VALUE | --results=VALUE] [-t DELAY | --timeout=DELAY] [-v | --version] [-V | --verbose] <KEYWORD> <+KEYWORD> | <URI> <+URI>

DESCRIPTION
Search for content on GNUnet. The keywords are case-sensitive. gnunet-search can be used both for a search in the global namespace as well as for searching a private subspace. The options are as follows:

-a LEVEL | --anonymity=LEVEL
    This option can be used to specify additional anonymity constraints. The default is 1. If set to 0, GNUnet will publish the file non-anonymously and in fact sign the advertisement for the file using your peer's private key. This will allow other users to download the file as fast as possible, including using non-anonymous methods (discovery via DHT and CADET transfer). If you set it to 1 (default), you use the standard anonymous routing algorithm (which does not explicitly leak your identity). However, a powerful adversary may still be able to perform traffic analysis (statistics) to over time discovery your identity. You can gain better privacy by specifying a higher level of anonymity (using values above 1). This tells FS that it must hide your own requests in equivalent-looking cover traffic. This should confound an adversaries traffic analysis, increasing the time and effort it would take to discover your identity. However, it also can significantly reduce performance, as your requests will be delayed until sufficient cover traffic is available. The specific numeric value (for anonymity levels above 1) is simple: Given an anonymity level L (above 1), each request FS makes on your behalf must be hidden in L-1 equivalent requests of cover traffic (traffic your peer routes for others) in the same time-period. The time-period is twice the average delay by which GNUnet artificially delays traffic. Note that regardless of the anonymity level you choose, peers that cache content in the network always use anonymity level 1.

-c FILENAME | --config=FILENAME
    Use the configuration file FILENAME (default: ~/.config/gnunet.conf)

-h | --help
    Print the help page.

-L LOGLEVEL | --loglevel=LOGLEVEL
    Change the loglevel. Possible values for LOGLEVEL are ERROR, WARNING, INFO and DEBUG.

-l FILENAME | --logfile=FILENAME
    Write logs to FILENAME.

-o FILENAME | --output=FILENAME
    Writes a GNUnet directory containing all of the search results to FILENAME.

-n | --no-network
    Only search locally, do not forward requests to other peers.

-N VALUE | --results=VALUE
    Automatically terminate the search after receiving VALUE results.

-t DELAY | --timeout=DELAY
    Automatically timeout search after DELAY. The value given must be a number followed by a space and a time unit, for example "500 ms". Note that the quotes are required on the shell. Otherwise the search runs until gnunet-search is aborted with CTRL-C.

-v | --version
    print the version number

-V | --verbose
    print meta data from search results as well
You can run gnunet-search with an URI instead of a keyword. The URI can have the format for a namespace search or for a keyword search. For a namespace search, the format is

    gnunet://fs/sks/NAMESPACE/IDENTIFIER

For a keyword search, use

    gnunet://fs/ksk/KEYWORD[+KEYWORD]*

If the format does not correspond to a GNUnet URI, GNUnet will automatically assume that keywords are supplied directly.

If multiple keywords are passed, gnunet-search will look for content matching any of the keywords. The prefix "+" makes a keyword mandatory.

FILES
~/.config/gnunet.conf GNUnet configuration file; specifies the default value for the timeout

EXAMPLES
    $ gnunet-search Das Kapital

Searches for content matching the keyword "Das Kapital".

    $ gnunet-search +Das +Kapital

Searches for content matching both mandatory keywords "Das" and "Kapital".

Search results are printed by gnunet-search like this:

gnunet-download -o "COPYING" gnunet://fs/chk/HASH1.HASH2.SIZE Description: The GNU General Public License Mime-type: text/plain The first line contains the command to run to download the file. The suggested filename in the example is COPYING. The GNUnet URI consists of the key and query hash of the file and finally the size of the file. After the command to download the file, GNUnet will print meta-data about the file as advertised in the search result. The meta-data here is the description ("The GNU General Public License") and the mime-type ("text-plain"). See the options for gnunet-publish(1) on how to supply meta-data by hand.

SEE ALSO
gnunet-download(1), gnunet-fs-gtk(1), gnunet-publish(1), gnunet.conf(5)

The full documentation for gnunet is maintained as a Texinfo manual. If the info(1) and gnunet programs are properly installed at your site, the command

    info gnunet

should give you access to the complete handbook,

    info gnunet-c-tutorial

will give you access to a tutorial for developers.

Depending on your installation, this information is also available in gnunet(7) and gnunet-c-tutorial(7).

BUGS
Report bugs by using https://bugs.gnunet.org or by sending electronic mail to <gnunet-developers@gnu.org>.